;; Copyright (c) 1998 David Kuehling

;; This software is provided 'as-is', without any express or implied
;; warranty. In no event will the authors be held liable for any damages
;; arising from the use of this software.

;; Permission is granted to anyone to use this software for any purpose,
;; including commercial applications, and to alter it and redistribute it
;; freely, subject to the following restrictions:

;; 1. The origin of this software must not be misrepresented; you must not
;;    claim that you wrote the original software. If you use this software
;;    in a product, an acknowledgment in the product documentation would be
;;    appreciated but is not required.
;; 2. Altered source versions must be plainly marked as such, and must not be
;;    misrepresented as being the original software.
;; 3. This notice may not be removed or altered from any source distribution.

        INCLUDE "ugplib.h"
        INCLUDE "tios.h"
        INCLUDE "flib.h"

        XDEF    _main
        XDEF    _tibasic


;----------------------------------
; MAIN
;----------------------------------
_main:
        lea     tios::FindSymEntry, a4    ;is used 3 times
        movea.l a7, a3                    ;save a7

                ;---- Get The Parameter ----
                ;- thanks to Teyssier Marc -

        move.w  #1020, d6                 ;Errornum: Internal error
        pea     Parameter(pc)             ;get the handle address of the parameter
        move.w  tios::DefTempHandle, -(a7)
        jsr     (a4)
        move.l  a0, d0                    ;if a0.l=0 no argument!
        beq     Error                     ;Error: Internal Error

        move.w  #130, d6                  ;Errornum: Argument must be a string
        move.w  tios::SYM_ENTRY.hVal(a0), d0
        tios::DEREF  d0, a0
        move.w  (a0), d0                  ;(a0) = var size
        lea     1(a0,d0.w), a1            ;1(a0,d0.w) points to var type
        cmp.b   #$2D, (a1)                ;$2D=string
        bne     Error

                ;---- Get Var Name&Folder ----

        lea     3(a0), a6                 ;a6 points to string

        ; char *strchr(char *s, int c)
        move.w  #'\', -(a7)               ;get address of backslash
        pea     (a6)
        jsr     tios::strchr
        movea.l a0, a5
                                          ;if (no backslash in string)
        move.l  a5, d0                    ;{
        bne     \FolderSpecified          ;
        movea.l a6, a5                    ;  var    = a5 = String
        lea     MainStr(PC), a6           ;  folder = a6 = MainStr
        bra     \FolderDone               ;}
                                          ;else
\FolderSpecified:                         ;{
        clr.b  (a5)+                      ;  var    = a5 = *backslash+1
                                          ;  folder = a6 = String
\FolderDone:                              ;}
 
                ;---- Get Address of Var ----
        move.w  #960, d6                  ;Errornum: Undefined variable

        ; SYM_ENTRY *FindSymEntry(WORD symlist, BYTE *name)
        pea     (a6)                      ;get handle of folder
        move.w  FOLDER_LIST_HANDLE, -(a7)

        moveq.w #1, d5                    ;d5 = 1 = counter
\getEntry:
        jsr     (a4)
        move.l  a0, d0
        beq     Error                     ;if a0=0: Error: Undefined var

        pea     (a5)                      ;get handle of variable
        move.w  tios::SYM_ENTRY.hVal(a0), -(a7)  ;handle of folder
        dbra    d5, \getEntry
                                          ;handle of var
        move.w  (a7)+, d0
        addq.l  #4, a7

        tios::DEREF d0, a6
        addq.w  #2, a6                    ;a6 = *EXTENDED_UGP
 
                ;---- Show UGP Title&picture ----

        move.w  #1020, d6                 ;Errornum: Internal Error

        cmp.l   #$55475000, (a6)+         ;check UGP Signature ("UGP\0")
        bne     Error                     ;if not equal: Error: Internal Error

        jsr     flib::clr_scr
        pea     Copyright(PC)
        jsr     tios::ST_showHelp

        move.w  #2, -(a7)                 ;huge script!
        jsr     tios::FontSetSys

        pea     (a6)                      ;get length of UGP title
        jsr     tios::strlen
        lea     1(a6, d0.w), a5           ;a5 = *StringEnd

        ; void DrawStrXY(WORD x, WORD y, BYTE *string, WORD color)
        move.w  #4, -(a7)                 ;print Title
        pea     (a6)
        move.w  #55, -(a7)

        moveq   #-1, d0                   ;get string length, and pointer to end
\TitleStrLoop:
        addq.w  #1, d0
        tst.b   (a6)+
        bne     \TitleStrLoop

        lsl.w   #2, d0                    ;get X-korrdinate, to center title
        subi.w  #120, d0
        neg.w   d0

        move.w  d0, -(a7)
        jsr     tios::DrawStrXY

        jsr     flib::idle_loop

        move.l  a6, d0                    ;get the next even address
        addq.l  #1, d0                   
        bclr    #0, d0
        movea.l d0, a0

        move.w  (a0)+, d2                 ;d2 = delaytime per picture

        jsr     ugplib::AutoDisp          ;display picture (a0) with speed d2
        tst.b   d0
        beq     End
	
                                          ;if error: Error: Internal error
;--------------------------------------
; Display an error message and exit
;--------------------------------------
Error:
        move.w  d6, -(a7)
        jsr     tios::ERD_dialog

End:    movea.l a3, a7                    ;restore a7 (remove all those args)
        rts                               ;exit programm




;----------------------------------------------------------------------------;
; DATA                                                                       ;
;----------------------------------------------------------------------------;

MainStr:        dc.b "main", 0
Parameter:      dc.b "x", 0
Copyright:      dc.b "UGPVIEW 1.02 - COPYRIGHT (C) 1998 DAVID KUEHLING", 0

;----------------------------------------------------------------------------;
; PROGRAMM HEADER FOR ARGUMENTS                                              ;
;----------------------------------------------------------------------------;
        ;(thanks to Teyssier Marc)
        SECTION _tibasic

        dc.b $E9
        dc.b $12,$E4  ; EndPrgm
        dc.b $00,$E8  ; :
        dc.b $19,$E4  ; Prgm
        dc.b $E5,$08  ; (x)
        dc.b $00,$00,$40,$DC

_tibasic
;*****************************************************

        END
